Attribute VB_Name = "Module1"
' _________________________________________________
'    routines communes  tous les programmes
'__________________________________________________
#If Win32 Then
  Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
  Declare Function WritePrivateProfileString Lib "kernel32" Alias "WritePrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpString As Any, ByVal lplFileName As String) As Long
#Else
  Declare Function GetPrivateProfileString Lib "Kernel" (ByVal Secname1$, ByVal Keynamei$, ByVal Def1$, ByVal Ret1$, ByVal Size1%, ByVal lpFileName$) As Integer
  Declare Function WritePrivateProfileString% Lib "Kernel" (ByVal lpAppName$, ByVal lpKeyName$, ByVal lpString$, ByVal lpFileName$)
#End If

Global Bug%    ' >0 si 'BUG" dans la ligne de commande (mode debugage)
Global CrLf$
Global FichierIni$, FichierHelp$
Global Nouveau% ' =1 si nouveau fichier INI

Function InitVar() As String
    CrLf$ = Chr$(13) + Chr$(10)
    Bug% = InStr(UCase$(Command$), "BUG")
    FichierIni$ = App.Path + "\" + App.EXEName + ".INI"
    FichierHelp$ = App.Path + "\" + App.EXEName + "Aide.TXT"

    FichierIniOld$ = Rdata("Parametre", "FichierINI", "", "")

    If FichierIniOld$ <> FichierIni$ Then Nouveau% = 1
    InitVar = App.Path + "\" + App.EXEName
End Function
Function Rdata(Paragraphe$, Rubrique$, Defaut$, Fichier$) As String
' S$ = Rdata(Paragraphe$, Rubrique$, Defaut$, Fichier$)
'   Paragraphe$ = [Section_a_lire]
'   Rubrique$   = Ligne  lire
'   Defaut$     = Valeur par dfaut si pas trouv
'   Fichier$    = Fichier  lire ("" si .INI)
Dim strIniBuffer As String * 255
If Fichier$ = "" Then Fichier$ = FichierIni$
On Error GoTo gisErr

  #If Win32 Then
    Dim lRetLen As Long
    lRetLen = GetPrivateProfileString(Paragraphe$, Rubrique$, Defaut$, strIniBuffer, 255, Fichier$)
    If lRetLen > 0 Then Rdata = Left$(strIniBuffer, lRetLen)
  #Else
    Dim nRetLen As Integer
    nRetLen = GetPrivateProfileString(Paragraphe$, Rubrique$, Defaut$, strIniBuffer, 255, Fichier$)
    If nRetLen > 0 Then Rdata = Left$(strIniBuffer, nRetLen)
  #End If

  Exit Function

gisErr:
' mettre ici une gestion d'erreur
  Resume gisExit

gisExit:
End Function
Sub Wdata(Paragraphe$, Rubrique$, Valeur$, Fichier$)
' Call Wdata(Paragraphe$, Rubrique$, Valeur$, Fichier$)
'   Paragraphe$ = [Section_a_lire]
'   Rubrique$   = Ligne  lire
'   Valeur$     = Valeur  sauvegarder
'   Fichier$    = Fichier  lire ("" si .INI)
  Dim sIniGroupKey As String
  If Fichier$ = "" Then Fichier$ = FichierIni$
  On Error GoTo sisErr

  #If Win32 Then
  Dim lTmp As Long
  lTmp = WritePrivateProfileString(Paragraphe$, Rubrique$, Valeur$, Fichier$)
  #Else
  Dim ntmp As Integer
  ntmp = WritePrivateProfileString(Paragraphe$, Rubrique$, Valeur$, Fichier$)
  #End If
  Exit Sub

sisErr:
' mettre ici une gestion d'erreur
  Resume sisExit

sisExit:
End Sub
Function PathExtFilter(Fichier$, PEF$)
' valeurs par dfaut
p$ = App.Path + "\"
E$ = ""
F$ = "Tous fichiers (*.*)|*.*"

If Fichier$ <> "" Then
' recherche du path
    i% = 0
    Do
        J% = i% + 1
        i% = InStr(J%, Fichier$, "\")
    Loop Until i% = 0
'Debug.Print J%, Left$(Fichier$, J% - 1)
    If J% > 1 Then  'y a un \
        p$ = Left$(Fichier$, J% - 1)
        ' test si valable
'Debug.Print Dir(P$ + "*.*")
        K% = FreeFile
        On Error Resume Next
        Open p$ + "_YGYGYG.tmp" For Binary As #K%
        L% = Err
        Close #K%
        Kill p$ + "_YGYGYG.tmp"
        If L% > 0 Then p$ = App.Path + "\"
        On Error GoTo 0
    Else    ' pas de /
        i% = InStr(Fichier$, ":")
        If i% = 2 Then p$ = Left$(Fichier$, 2) Else p$ = ""
    End If
' recherche de l'extension
    S$ = Trim$(Mid$(Fichier$ + "  ", J%)): E$ = ""
    If S$ <> "" Then
        For i% = Len(S$) To 1 Step -1
            If Mid$(S$, i%, 1) = "\" Then Exit For    ' pas d'extension
            If Mid$(S$, i%, 1) = "." Then
                E$ = Trim$(Mid$(S$ + "   ", i% + 1))
                Exit For    ' extension trouve
            End If
        Next i%
    End If
' recherche du filtre
    If E$ = "" Then
        'E$ = "TMP"
    Else
        F$ = "fichiers (*." + E$ + ")|*." + E$ + "|" + F$
    End If
        
End If

' Rsultat
Select Case Asc(UCase$(PEF$))
    Case Asc("P")
        PathExtFilter = p$
    Case Asc("E")
        PathExtFilter = E$
    Case Asc("F")
        PathExtFilter = F$
    Case Else
        i% = MsgBox("argument """ + PEF$ + """ non valable", 0, "Erreur")
End Select
'Debug.Print "Path   = "; P$
'Debug.Print "EXT    = "; E$
'Debug.Print "Filtre = "; F$
End Function
Sub SauvePositionFeuille(Feuille As Form, Fichier$)
Static N% ' compteur de feuille  sauvegarder
    Call Wdata("Position_" + Format$(N%), "Haut", Format$(Feuille.Top), Fichier$)
    Call Wdata("Position_" + Format$(N%), "Droite", Format$(Feuille.Left), Fichier$)
    Call Wdata("Position_" + Format$(N%), "Hauteur", Format$(Feuille.Height), Fichier$)
    Call Wdata("Position_" + Format$(N%), "Largeur", Format$(Feuille.Width), Fichier$)
N% = N% + 1
End Sub
Sub RestorePositionFeuille(Feuille As Form, Fichier$, PD$)
Static N%
If InStr(UCase$(PD$), "P") > 0 Then
    Feuille.Top = Val(Rdata("Position_" + Format$(N%), "Haut", "", Fichier$))
    Feuille.Left = Val(Rdata("Position_" + Format$(N%), "Droite", "", Fichier$))
End If
If InStr(UCase$(PD$), "D") > 0 Then
    S1$ = Rdata("Position_" + Format$(N%), "Hauteur", "", Fichier$)
    S2$ = Rdata("Position_" + Format$(N%), "Largeur", "", Fichier$)

    If S1$ <> "" Then Feuille.Height = Val(S$)
    If S2$ <> "" Then Feuille.Width = Val(S$)
End If
N% = N% + 1
End Sub




